// @generated automatically by Diesel CLI.

diesel::table! {
    hotel (id) {
        id -> Int4,
        #[max_length = 255]
        name -> Varchar,
        #[max_length = 255]
        address -> Varchar,
    }
}

diesel::table! {
    reservation (id) {
        id -> Int4,
        room_id -> Int4,
        start -> Timestamp,
        end -> Timestamp,
        #[max_length = 255]
        user -> Varchar,
        checked_in -> Bool,
    }
}

diesel::table! {
    room (id) {
        id -> Int4,
        hotel_id -> Int4,
        beds -> Int4,
        size -> Int4,
    }
}

diesel::table! {
    session (id) {
        #[max_length = 128]
        id -> Varchar,
        data -> Jsonb,
        expiry_date -> Timestamp,
    }
}

diesel::table! {
    task (id) {
        id -> Int4,
        room_id -> Int4,
        description -> Text,
        #[max_length = 12]
        status -> Varchar,
    }
}

diesel::table! {
    user (email) {
        #[max_length = 255]
        email -> Varchar,
        #[max_length = 255]
        hash -> Varchar,
        #[max_length = 255]
        salt -> Varchar,
        role -> Int2,
    }
}

diesel::joinable!(reservation -> room (room_id));
diesel::joinable!(reservation -> user (user));
diesel::joinable!(room -> hotel (hotel_id));
diesel::joinable!(task -> room (room_id));

diesel::allow_tables_to_appear_in_same_query!(
    hotel,
    reservation,
    room,
    session,
    task,
    user,
);
