use crate::error::AppError;
use crate::models::task::{Task, TaskStatus};
use crate::schema::task;
use diesel::expression_methods::ExpressionMethods;
use diesel::QueryDsl;
use diesel_async::{AsyncPgConnection, RunQueryDsl};

impl Task {
    pub async fn set_description(
        id: i32,
        description: String,
        conn: &mut AsyncPgConnection,
    ) -> Result<(), AppError> {
        diesel::update(task::table.find(id))
            .set(task::description.eq(description))
            .execute(conn)
            .await?;
        Ok(())
    }

    pub async fn set_status(
        id: i32,
        status: TaskStatus,
        conn: &mut AsyncPgConnection,
    ) -> Result<(), AppError> {
        diesel::update(task::table.find(id))
            .set(task::status.eq(status.to_string()))
            .execute(conn)
            .await?;
        Ok(())
    }
}

#[cfg(test)]
mod tests {
    // TODO
}
